structure Fomega =
  struct
    type expvar = Variables.exp Variable.var
    type convar = Variables.con Variable.var


    datatype kind =
        KndType
      | KndArrow of kind * kind

    datatype con =
        ConVar of convar
      | TyArrow of con * con
      | TyForall of convar * kind * con
      | ConAbs of convar * kind * con
      | ConApp of con * con

    datatype exp =
        ExVar of expvar
      | ExAbs of expvar * con * exp
      | ExApp of exp * exp
      | ExConAbs of convar * kind * exp
      | ExConApp of exp * con
    
  end
