signature TYPECHECK =
  sig
    exception Check of string
    exception Error of string

    structure Ctx : CONTEXT
                    where type con = Fomega.con
                      and type kind = Fomega.kind

    type context = Ctx.context

    val equiv_con : context -> Fomega.con -> Fomega.con -> Fomega.kind -> bool

    val check_con : context -> Fomega.con -> Fomega.kind
    val check_exp : context -> Fomega.exp -> Fomega.con
  end
