signature PRINT =
  sig
    val kind_to_layout : Fomega.kind -> Layout.layout
    val con_to_layout : Fomega.con -> Layout.layout
    val exp_to_layout : Fomega.exp -> Layout.layout

    val kind_to_string : Fomega.kind -> string
    val con_to_string : Fomega.con -> string
    val exp_to_string : Fomega.exp -> string

    val print_kind : Fomega.kind -> unit
    val print_con : Fomega.con -> unit
    val print_exp : Fomega.exp -> unit
  end
